from fish_collector import getSpeciesList, getInformSelectSpecies


def test_integrationList():
    right_list = [{'name': 'Crimson Jobfish', 'path': 'crimson-jobfish'}, {'name': 'White Hake', 'path': 'white-hake'}, {'name': 'Atlantic Chub Mackerel', 'path': 'atlantic-chub-mackerel'}, {'name': 'Shortfin Squid', 'path': 'shortfin-squid'}, {'name': 'American Lobster', 'path': 'american-lobster'}, {'name': 'Yellowtail Rockfish', 'path': 'yellowtail-rockfish'}, {'name': 'Bocaccio', 'path': 'bocaccio'}, {'name': 'Sugar Kelp', 'path': 'sugar-kelp-farmed'}, {'name': 'Sablefish', 'path': 'sablefish-farmed'}, {'name': 'Atlantic Halibut', 'path': 'atlantic-halibut'}, {'name': 'Shortspine Thornyhead', 'path': 'shortspine-thornyhead'}, {'name': 'Canary Rockfish', 'path': 'canary-rockfish'}, {'name': 'Black Grouper', 'path': 'black-grouper'}, {'name': 'Striped Marlin', 'path': 'striped-marlin'}, {'name': 'Blueline Tilefish', 'path': 'blueline-tilefish'}, {'name': 'Red Hake', 'path': 'red-hake'}, {'name': 'Atlantic Sharpnose Shark', 'path': 'atlantic-sharpnose-shark'}, {'name': 'Pacific Sardine', 'path': 'pacific-sardine'}, {'name': 'Pacific Oyster', 'path': 'pacific-oyster-farmed'}, {'name': 'Hard Clam/Northern Quahog', 'path': 'northern-quahog'}, {'name': 'Geoduck ', 'path': 'geoduck-farmed'}, {'name': 'Eastern Oyster', 'path': 'eastern-oyster-farmed'}, {'name': 'Blue Mussel', 'path': 'blue-mussel-farmed'}, {'name': 'Atlantic Salmon', 'path': 'atlantic-salmon-farmed'}, {'name': 'Butterfish', 'path': 'butterfish'}, {'name': 'Winter Skate', 'path': 'winter-skate'}, {'name': 'Pink Salmon', 'path': 'pink-salmon'}, {'name': 'Atlantic Northern Shrimp', 'path': 'atlantic-northern-shrimp'}, {'name': 'North Pacific Swordfish', 'path': 'north-pacific-swordfish'}, {'name': 'Atlantic Mackerel', 'path': 'atlantic-mackerel'}, {'name': 'Atlantic Bigeye Tuna', 'path': 'atlantic-bigeye-tuna'}, {'name': 'North Atlantic Albacore Tuna', 'path': 'north-atlantic-albacore-tuna'}, {'name': 'Acadian Redfish', 'path': 'acadian-redfish'}, {'name': 'Atlantic Skipjack Tuna', 'path': 'atlantic-skipjack-tuna'}, {'name': 'Atlantic Sea Scallop', 'path': 'atlantic-sea-scallop'}, {'name': 'Atlantic Salmon', 'path': 'atlantic-salmon'}, {'name': 'Atlantic Pollock', 'path': 'atlantic-pollock'}, {'name': 'Atlantic Yellowfin Tuna', 'path': 'atlantic-yellowfin-tuna'}, {'name': 'Longfin Inshore Squid', 'path': 'longfin-squid'}, {'name': 'Scup', 'path': 'scup'}, {'name': 'Pink Shrimp', 'path': 'pink-shrimp'}, {'name': 'White Shrimp', 'path': 'white-shrimp'}, {'name': 'Silver Hake', 'path': 'silver-hake'}, {'name': 'Pacific Skipjack Tuna', 'path': 'pacific-skipjack-tuna'}, {'name': 'North Atlantic Swordfish', 'path': 'north-atlantic-swordfish'}, {'name': 'Brown Rock Shrimp', 'path': 'brown-rock-shrimp'}, {'name': 'Yellowtail Flounder', 'path': 'yellowtail-flounder'}, {'name': 'Winter Flounder', 'path': 'winter-flounder'}, {'name': 'Coho Salmon', 'path': 'coho-salmon'}, {'name': 'Chum Salmon', 'path': 'chum-salmon'}, {'name': 'Brown Shrimp', 'path': 'brown-shrimp'}, {'name': 'Pacific Mackerel', 'path': 'pacific-mackerel'}, {'name': 'Pacific Bluefin Tuna', 'path': 'pacific-bluefin-tuna'}, {'name': 'Opah', 'path': 'opah'}, {'name': 'Atlantic Herring', 'path': 'atlantic-herring'}, {'name': 'Vermilion Snapper', 'path': 'vermilion-snapper'}, {'name': 'Atlantic Blacktip Shark', 'path': 'atlantic-blacktip-shark'}, {'name': 'Haddock', 'path': 'haddock'}, {'name': 'Chinook Salmon', 'path': 'chinook-salmon'}, {'name': 'Pacific Bigeye Tuna', 'path': 'pacific-bigeye-tuna'}, {'name': 'Atlantic Shortfin Mako Shark', 'path': 'atlantic-shortfin-mako-shark'}, {'name': 'Atlantic Common Thresher Shark', 'path': 'atlantic-common-thresher-shark'}, {'name': 'Yellowfin Sole', 'path': 'yellowfin-sole'}, {'name': 'Pacific Yellowfin Tuna', 'path': 'pacific-yellowfin-tuna'}, {'name': 'Pacific Whiting', 'path': 'pacific-whiting'}, {'name': 'Spanish Mackerel', 'path': 'spanish-mackerel'}, {'name': 'Rock Sole', 'path': 'rock-sole'}, {'name': 'Pacific Wahoo', 'path': 'pacific-wahoo'}, {'name': 'King Mackerel', 'path': 'king-mackerel'}, {'name': 'Greenland Turbot', 'path': 'greenland-turbot'}, {'name': 'California Market Squid', 'path': 'california-market-squid'}, {'name': 'Atlantic Wahoo', 'path': 'atlantic-wahoo'}, {'name': 'Gag Grouper', 'path': 'gag-grouper'}, {'name': 'Flathead Sole', 'path': 'flathead-sole'}, {'name': 'Summer Flounder', 'path': 'summer-flounder'}, {'name': 'Rex Sole', 'path': 'rex-sole'}, {'name': 'Red Grouper', 'path': 'red-grouper'}, {'name': 'English Sole', 'path': 'english-sole'}, {'name': 'Dover Sole', 'path': 'dover-sole'}, {'name': 'Caribbean Spiny Lobster', 'path': 'caribbean-spiny-lobster'}, {'name': 'Pacific Albacore Tuna', 'path': 'pacific-albacore-tuna'}, {'name': 'Wreckfish', 'path': 'wreckfish'}, {'name': 'Queen Conch', 'path': 'queen-conch'}, {'name': 'Red King Crab', 'path': 'red-king-crab'}, {'name': 'Pacific Spiny Dogfish', 'path': 'pacific-spiny-dogfish'}, {'name': 'Pacific Halibut', 'path': 'pacific-halibut'}, {'name': 'Atlantic Spiny Dogfish', 'path': 'atlantic-spiny-dogfish'}, {'name': 'Arrowtooth Flounder', 'path': 'arrowtooth-flounder'}, {'name': 'Alaska Snow Crab', 'path': 'alaska-snow-crab'}, {'name': 'Ocean Quahog', 'path': 'ocean-quahog'}, {'name': 'Gray Triggerfish', 'path': 'gray-triggerfish'}, {'name': 'Bluefish', 'path': 'bluefish'}, {'name': 'Black Sea Bass', 'path': 'black-sea-bass'}, {'name': 'Petrale Sole', 'path': 'petrale-sole'}, {'name': 'Greater Amberjack', 'path': 'greater-amberjack'}, {'name': 'Pacific Common Thresher Shark', 'path': 'pacific-common-thresher-shark'}, {'name': 'Pacific Cod', 'path': 'pacific-cod'}, {'name': 'Pacific Blue Marlin', 'path': 'pacific-blue-marlin'}, {'name': 'Northern Anchovy', 'path': 'northern-anchovy'}, {'name': 'Lingcod', 'path': 'lingcod'}, {'name': 'Atlantic Striped Bass', 'path': 'atlantic-striped-bass'}, {'name': 'Atlantic Surfclam', 'path': 'atlantic-surfclam'}, {'name': 'Pacific Shortfin Mako Shark', 'path': 'pacific-shortfin-mako-shark'}, {'name': 'Pacific Ocean Perch', 'path': 'pacific-ocean-perch'}, {'name': 'Pacific Mahimahi', 'path': 'pacific-mahimahi'}, {'name': 'Widow Rockfish', 'path': 'widow-rockfish'}, {'name': 'Western Atlantic Bluefin Tuna', 'path': 'western-atlantic-bluefin-tuna'}, {'name': 'Tilefish', 'path': 'tilefish'}, {'name': 'Red Snapper', 'path': 'red-snapper'}, {'name': 'Sockeye Salmon', 'path': 'sockeye-salmon'}, {'name': 'Sablefish', 'path': 'sablefish'}, {'name': 'Alaska Pollock', 'path': 'alaska-pollock'}, {'name': 'Monkfish', 'path': 'monkfish'}, {'name': 'Atlantic Mahi Mahi', 'path': 'atlantic-mahi-mahi'}, {'name': 'Cobia', 'path': 'cobia'}, {'name': 'Atlantic Cod', 'path': 'atlantic-cod'}]
    received_list = getSpeciesList()
    assert right_list == received_list

def test_integrationErrorList():
    right_list = [{'namee': 'Crimson Jobfish', 'path': 'crimson-jobfish'}, {'name': 'White Hake', 'path': 'white-hake'}, {'name': 'Atlantic Chub Mackerel', 'path': 'atlantic-chub-mackerel'}, {'name': 'Shortfin Squid', 'path': 'shortfin-squid'}, {'name': 'American Lobster', 'path': 'american-lobster'}, {'name': 'Yellowtail Rockfish', 'path': 'yellowtail-rockfish'}, {'name': 'Bocaccio', 'path': 'bocaccio'}, {'name': 'Sugar Kelp', 'path': 'sugar-kelp-farmed'}, {'name': 'Sablefish', 'path': 'sablefish-farmed'}, {'name': 'Atlantic Halibut', 'path': 'atlantic-halibut'}, {'name': 'Shortspine Thornyhead', 'path': 'shortspine-thornyhead'}, {'name': 'Canary Rockfish', 'path': 'canary-rockfish'}, {'name': 'Black Grouper', 'path': 'black-grouper'}, {'name': 'Striped Marlin', 'path': 'striped-marlin'}, {'name': 'Blueline Tilefish', 'path': 'blueline-tilefish'}, {'name': 'Red Hake', 'path': 'red-hake'}, {'name': 'Atlantic Sharpnose Shark', 'path': 'atlantic-sharpnose-shark'}, {'name': 'Pacific Sardine', 'path': 'pacific-sardine'}, {'name': 'Pacific Oyster', 'path': 'pacific-oyster-farmed'}, {'name': 'Hard Clam/Northern Quahog', 'path': 'northern-quahog'}, {'name': 'Geoduck ', 'path': 'geoduck-farmed'}, {'name': 'Eastern Oyster', 'path': 'eastern-oyster-farmed'}, {'name': 'Blue Mussel', 'path': 'blue-mussel-farmed'}, {'name': 'Atlantic Salmon', 'path': 'atlantic-salmon-farmed'}, {'name': 'Butterfish', 'path': 'butterfish'}, {'name': 'Winter Skate', 'path': 'winter-skate'}, {'name': 'Pink Salmon', 'path': 'pink-salmon'}, {'name': 'Atlantic Northern Shrimp', 'path': 'atlantic-northern-shrimp'}, {'name': 'North Pacific Swordfish', 'path': 'north-pacific-swordfish'}, {'name': 'Atlantic Mackerel', 'path': 'atlantic-mackerel'}, {'name': 'Atlantic Bigeye Tuna', 'path': 'atlantic-bigeye-tuna'}, {'name': 'North Atlantic Albacore Tuna', 'path': 'north-atlantic-albacore-tuna'}, {'name': 'Acadian Redfish', 'path': 'acadian-redfish'}, {'name': 'Atlantic Skipjack Tuna', 'path': 'atlantic-skipjack-tuna'}, {'name': 'Atlantic Sea Scallop', 'path': 'atlantic-sea-scallop'}, {'name': 'Atlantic Salmon', 'path': 'atlantic-salmon'}, {'name': 'Atlantic Pollock', 'path': 'atlantic-pollock'}, {'name': 'Atlantic Yellowfin Tuna', 'path': 'atlantic-yellowfin-tuna'}, {'name': 'Longfin Inshore Squid', 'path': 'longfin-squid'}, {'name': 'Scup', 'path': 'scup'}, {'name': 'Pink Shrimp', 'path': 'pink-shrimp'}, {'name': 'White Shrimp', 'path': 'white-shrimp'}, {'name': 'Silver Hake', 'path': 'silver-hake'}, {'name': 'Pacific Skipjack Tuna', 'path': 'pacific-skipjack-tuna'}, {'name': 'North Atlantic Swordfish', 'path': 'north-atlantic-swordfish'}, {'name': 'Brown Rock Shrimp', 'path': 'brown-rock-shrimp'}, {'name': 'Yellowtail Flounder', 'path': 'yellowtail-flounder'}, {'name': 'Winter Flounder', 'path': 'winter-flounder'}, {'name': 'Coho Salmon', 'path': 'coho-salmon'}, {'name': 'Chum Salmon', 'path': 'chum-salmon'}, {'name': 'Brown Shrimp', 'path': 'brown-shrimp'}, {'name': 'Pacific Mackerel', 'path': 'pacific-mackerel'}, {'name': 'Pacific Bluefin Tuna', 'path': 'pacific-bluefin-tuna'}, {'name': 'Opah', 'path': 'opah'}, {'name': 'Atlantic Herring', 'path': 'atlantic-herring'}, {'name': 'Vermilion Snapper', 'path': 'vermilion-snapper'}, {'name': 'Atlantic Blacktip Shark', 'path': 'atlantic-blacktip-shark'}, {'name': 'Haddock', 'path': 'haddock'}, {'name': 'Chinook Salmon', 'path': 'chinook-salmon'}, {'name': 'Pacific Bigeye Tuna', 'path': 'pacific-bigeye-tuna'}, {'name': 'Atlantic Shortfin Mako Shark', 'path': 'atlantic-shortfin-mako-shark'}, {'name': 'Atlantic Common Thresher Shark', 'path': 'atlantic-common-thresher-shark'}, {'name': 'Yellowfin Sole', 'path': 'yellowfin-sole'}, {'name': 'Pacific Yellowfin Tuna', 'path': 'pacific-yellowfin-tuna'}, {'name': 'Pacific Whiting', 'path': 'pacific-whiting'}, {'name': 'Spanish Mackerel', 'path': 'spanish-mackerel'}, {'name': 'Rock Sole', 'path': 'rock-sole'}, {'name': 'Pacific Wahoo', 'path': 'pacific-wahoo'}, {'name': 'King Mackerel', 'path': 'king-mackerel'}, {'name': 'Greenland Turbot', 'path': 'greenland-turbot'}, {'name': 'California Market Squid', 'path': 'california-market-squid'}, {'name': 'Atlantic Wahoo', 'path': 'atlantic-wahoo'}, {'name': 'Gag Grouper', 'path': 'gag-grouper'}, {'name': 'Flathead Sole', 'path': 'flathead-sole'}, {'name': 'Summer Flounder', 'path': 'summer-flounder'}, {'name': 'Rex Sole', 'path': 'rex-sole'}, {'name': 'Red Grouper', 'path': 'red-grouper'}, {'name': 'English Sole', 'path': 'english-sole'}, {'name': 'Dover Sole', 'path': 'dover-sole'}, {'name': 'Caribbean Spiny Lobster', 'path': 'caribbean-spiny-lobster'}, {'name': 'Pacific Albacore Tuna', 'path': 'pacific-albacore-tuna'}, {'name': 'Wreckfish', 'path': 'wreckfish'}, {'name': 'Queen Conch', 'path': 'queen-conch'}, {'name': 'Red King Crab', 'path': 'red-king-crab'}, {'name': 'Pacific Spiny Dogfish', 'path': 'pacific-spiny-dogfish'}, {'name': 'Pacific Halibut', 'path': 'pacific-halibut'}, {'name': 'Atlantic Spiny Dogfish', 'path': 'atlantic-spiny-dogfish'}, {'name': 'Arrowtooth Flounder', 'path': 'arrowtooth-flounder'}, {'name': 'Alaska Snow Crab', 'path': 'alaska-snow-crab'}, {'name': 'Ocean Quahog', 'path': 'ocean-quahog'}, {'name': 'Gray Triggerfish', 'path': 'gray-triggerfish'}, {'name': 'Bluefish', 'path': 'bluefish'}, {'name': 'Black Sea Bass', 'path': 'black-sea-bass'}, {'name': 'Petrale Sole', 'path': 'petrale-sole'}, {'name': 'Greater Amberjack', 'path': 'greater-amberjack'}, {'name': 'Pacific Common Thresher Shark', 'path': 'pacific-common-thresher-shark'}, {'name': 'Pacific Cod', 'path': 'pacific-cod'}, {'name': 'Pacific Blue Marlin', 'path': 'pacific-blue-marlin'}, {'name': 'Northern Anchovy', 'path': 'northern-anchovy'}, {'name': 'Lingcod', 'path': 'lingcod'}, {'name': 'Atlantic Striped Bass', 'path': 'atlantic-striped-bass'}, {'name': 'Atlantic Surfclam', 'path': 'atlantic-surfclam'}, {'name': 'Pacific Shortfin Mako Shark', 'path': 'pacific-shortfin-mako-shark'}, {'name': 'Pacific Ocean Perch', 'path': 'pacific-ocean-perch'}, {'name': 'Pacific Mahimahi', 'path': 'pacific-mahimahi'}, {'name': 'Widow Rockfish', 'path': 'widow-rockfish'}, {'name': 'Western Atlantic Bluefin Tuna', 'path': 'western-atlantic-bluefin-tuna'}, {'name': 'Tilefish', 'path': 'tilefish'}, {'name': 'Red Snapper', 'path': 'red-snapper'}, {'name': 'Sockeye Salmon', 'path': 'sockeye-salmon'}, {'name': 'Sablefish', 'path': 'sablefish'}, {'name': 'Alaska Pollock', 'path': 'alaska-pollock'}, {'name': 'Monkfish', 'path': 'monkfish'}, {'name': 'Atlantic Mahi Mahi', 'path': 'atlantic-mahi-mahi'}, {'name': 'Cobia', 'path': 'cobia'}, {'name': 'Atlantic Cod', 'path': 'atlantic-cod'}]
    received_list = getSpeciesList()
    assert right_list != received_list

def test_integrationSpecificSpecies1():
    right_text = [{'Fishery Management': '<ul>\n<li><a href="http://www.greateratlantic.fisheries.noaa.gov/index.html">NOAA Fisheries</a>, the <a href="http://www.mafmc.org/">Mid-Atlantic Fishery Management Council</a>, and the <a href="http://asmfc.org/" rel="external">Atlantic States Marine Fisheries Commission</a> manage the bluefish fishery.</li>\n<li>Managed under the <a href="http://www.mafmc.org/fisheries/fmp/bluefish">Bluefish Fishery Management Plan</a>:\n<ul>\n<li>Commercial fishermen must have a permit to catch and sell bluefish.</li>\n<li>Managers set an annual catch limit.</li>\n<li>The majority of catch is allocated to the recreational fisheries.</li>\n<li>The commercial catch limit is divided into state-specific allocations. Unused recreational catch can be re-allocated to commercial fisheries.</li>\n</ul>\n</li>\n</ul>\n', 'Habitat': '<ul>\n<li>Bluefish live in temperate and tropical coastal oceans around the world, except in the eastern Pacific.</li>\n<li>They gather by size in schools that can cover tens of square miles of ocean, equivalent to 10,000 football fields.</li>\n<li>Bluefish migrate seasonally, moving north in spring and summer as water temperatures rise and then south in autumn and winter to waters in the South Atlantic Bight.</li>\n<li>Females release their eggs in the open ocean.</li>\n<li>Larvae develop into juveniles near the surface in continental shelf waters and eventually move to estuarine and nearshore shelf habitats.</li>\n<li>Juveniles prefer sandy ocean bottoms but will also inhabit mud, silt, or clay ocean bottoms or vegetated areas.</li>\n<li>Adults live in both inshore and offshore areas and favor warmer water.</li>\n</ul>\n', 'Habitat Impacts': 'Recreational fishermen use hook-and-line gear that has minimal impacts on habitat. Commercial fishermen use a variety of gears including trawls, gillnets, haul seines, and pound nets, and the impacts vary by gear type.', 'Image Gallery': [{'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/01_10.jpg', 'alt': 'Bluefish have a prominent jaw, with sharp, compressed teeth.', 'title': 'Bluefish have a prominent jaw, with sharp, compressed teeth.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/02_8.jpg', 'alt': 'A recreational fisherman with his catch of bluefish. Bluefish are one of the most popular recreational species along the Atlantic coast.', 'title': 'A recreational fisherman with his catch of bluefish. Bluefish are one of the most popular recreational species along the Atlantic coast.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/03_6.jpg', 'alt': 'A historic photo of a crew of New York bluefish fisherman.', 'title': 'A historic photo of a crew of New York bluefish fisherman.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/05_7.jpg', 'alt': 'Filleting freshly-caught bluefish.', 'title': 'Filleting freshly-caught bluefish.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/06_3.jpg', 'alt': 'Bluefish in the pan.', 'title': 'Bluefish in the pan.'}], 'Location': '<ul>\n<li>Along the East Coast from Maine to eastern Florida.</li>\n</ul>\n', 'Management': None, 'NOAA Fisheries Region': 'Greater Atlantic', 'Population': 'Significantly below target population level. A rebuilding plan is in place.', 'Population Status': '<ul>\n<li>According to the 2021 stock assessment, bluefish is overfished and not subject to overfishing. Summary stock assessment information can be found on <a href="https://www.st.nmfs.noaa.gov/stocksmart?stockname=Bluefish%20-%20Atlantic%20Coast&amp;stockid=10388">Stock SMART</a>.</li>\n</ul>\n', 'Scientific Name': 'Pomatomus saltatrix', 'Species Aliases': '<a href="/species-aliases/tailor" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Tailor</a>, <a href="/species-aliases/snapper" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Snapper</a>, <a href="/species-aliases/baby-blues" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Baby blues</a>, <a href="/species-aliases/choppers" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Choppers</a>, <a href="/species-aliases/elfs" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Elfs</a>', 'Species Illustration Photo': {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/bluefish.png', 'alt': 'Bluefish', 'title': 'Bluefish'}, 'Species Name': 'Bluefish', 'Animal Health': None, 'Availability': '<p>Fresh year-round, but varies by area. Not available frozen. Buy in season, and plan to cook within a day of purchase.</p>\n', 'Biology': '<ul>\n<li>Bluefish live up to 12&nbsp;years.</li>\n<li>They grow fast, up to 31 pounds and 39 inches.</li>\n<li>They are able to reproduce at age 2, when they’re 15 to 20 inches in length.</li>\n<li>Depending on their size, females can have between 400,000 and 2 million eggs.</li>\n<li>Bluefish spawn multiple times in spring and summer.</li>\n<li>They exhibit feeding behavior called the “bluefish blitz,” where large schools of big fish attack bait fish near the surface, churning the water like a washing machine. They feed voraciously on their prey, eating almost anything they can catch and swallow.</li>\n<li>Bluefish have razor-sharp teeth and shearing jaws that allow them to ingest large parts, increasing the maximum size of the prey they can eat.</li>\n<li>They eat squid and fish, particularly menhaden and smaller fish such as silversides.</li>\n<li>Sharks, tunas, and billfishes are typically the only fish predators large and fast enough to prey on adult bluefish.</li>\n<li>Bluefish make up a major part of the diet of <a href="https://www.fishwatch.gov/profiles/atlantic-shortfin-mako-shark">shortfin mako sharks</a>&nbsp;and are also very important in the diets of <a href="https://www.fishwatch.gov/profiles/north-atlantic-swordfish">swordfish</a>.</li>\n<li>Oceanic birds prey on juvenile bluefish.</li>\n</ul>\n', 'Bycatch': 'Regulations are in place to minimize bycatch.', 'Calories': '124', 'Carbohydrate': '0 g', 'Cholesterol': '59 mg', 'Color': '<p>The meat of raw bluefish is light putty to blue-gray in color with a brownish tinge. It becomes lighter when cooked.</p>\n', 'Disease Treatment and Prevention': None, 'Diseases in Salmon': None, 'Displayed Seafood Profile Illustration': None, 'Ecosystem Services': None, 'Environmental Considerations': None, 'Environmental Effects': None, 'Farming Methods': None, 'Farming Methods_': None, 'Fat, Total': '4.24 g', 'Feeds_': None, 'Feeds': None, 'Fiber, Total Dietary': '0 g', 'Fishing Rate': 'At recommended level.', 'Harvest': '<ul>\n<li>In 2021, commercial landings of bluefish totaled more than 2.4 million pounds and were valued at $2.2 million, according to the NOAA Fisheries <a href="https://www.fisheries.noaa.gov/foss/f?p=215:200:3577333744020::NO:::">commercial fishing landings database</a>.</li>\n<li>In 2021, recreational anglers landed 12.8&nbsp;million pounds of bluefish, according to the NOAA Fisheries<a href="https://www.fisheries.noaa.gov/foss/f?p=215:200:3577333744020::NO:::"> recreational fishing landings database</a>.</li>\n<li>Florida, North Carolina, and New Jersey account for the largest percentage of the recreational bluefish harvest.</li>\n<li>Peak recreational harvest occurs from May through October with over 70 percent of the catch in July and August.</li>\n<li>Gear types, habitat impacts, and bycatch:\n<ul>\n<li>Recreational fishermen use hook-and-line gear that has minimal impacts on habitat.</li>\n<li>Commercial fishermen use a variety of gears including trawls, gillnets, haul seines, and pound nets, and the impacts vary by gear type.</li>\n<li>Gillnets can occasionally entangle marine mammals. However, the bluefish fishery uses nets with small mesh and sinking gillnets to reduce bycatch.</li>\n</ul>\n</li>\n</ul>\n', 'Harvest Type': 'Wild', 'Health Benefits': '<p>Bluefish are a good source of selenium, niacin, vitamin B12, magnesium, and potassium. As apex predators, bluefish can accumulate comparatively high levels of mercury and PCB contaminants. Limited consumption has been recommended in some states.</p>\n', 'Human_Health_': None, 'Human Health': None, 'Physical Description': '<ul>\n<li>Bluefish are blue-green on the back and silvery on the sides and belly.</li>\n<li>They have a prominent jaw, with sharp, compressed teeth.</li>\n</ul>\n', 'Production': None, 'Protein': '20.04 g', 'Quote': 'U.S. wild-caught bluefish is a smart seafood choice because it is sustainably managed and responsibly harvested under U.S. regulations.', 'Quote Background Color': '#89aec3', 'Research': '<ul>\n<li>Several key scientific gaps need to be addressed to better inform management. For example, more research is needed on the relationship between the age and length of bluefish, how much bluefish is caught and discarded in the commercial fisheries for bluefish and other species, the resulting impacts, and general population trends. There is also uncertainty in the methods used by scientists to monitor bluefish abundance and in estimating recreational catch along the Atlantic coast. In 2012, managers established a coast-wide sampling program designed to improve the quantity and quality of information used in future bluefish stock assessments.</li>\n<li>The coast-wide&nbsp;sampling program resulted in a significant increase in the amount of age-length keys and catch-at-age data that was used in the 2015 benchmark assessment.</li>\n<li>The bluefish management plan allows managers to set aside a small percentage of the annual catch limit for research. Proceeds from the sale of this set-aside catch are used to fund research on the bluefish resource and fishery.</li>\n</ul>\n', 'Saturated Fatty Acids, Total': '0.915 g', 'Selenium': '36.5 mcg', 'Serving Weight': '100 g', 'Servings': '1', 'Sodium': '60 mcg', 'Source': '<p>U.S. wild-caught from Massachusetts to Florida.</p>\n', 'Sugars, Total': '0 g', 'Taste': '<p>Rich, full flavor. The larger the fish, the more pronounced the taste. A strong-flavored, dark strip of meat on the fillet may be removed before cooking.</p>\n', 'Texture': '<p>Coarse, moist meat with edible skin.</p>\n', 'Path': '/profiles/bluefish', 'last_update': '10/05/2022 - 14:57'}]
    received_text = getInformSelectSpecies("Bluefish")
    assert right_text == received_text

def test_integrationErrorSpecificSpecies1():
    right_text = [{'Fisheryyy Management': '<ul>\n<li><a href="http://www.greateratlantic.fisheries.noaa.gov/index.html">NOAA Fisheries</a>, the <a href="http://www.mafmc.org/">Mid-Atlantic Fishery Management Council</a>, and the <a href="http://asmfc.org/" rel="external">Atlantic States Marine Fisheries Commission</a> manage the bluefish fishery.</li>\n<li>Managed under the <a href="http://www.mafmc.org/fisheries/fmp/bluefish">Bluefish Fishery Management Plan</a>:\n<ul>\n<li>Commercial fishermen must have a permit to catch and sell bluefish.</li>\n<li>Managers set an annual catch limit.</li>\n<li>The majority of catch is allocated to the recreational fisheries.</li>\n<li>The commercial catch limit is divided into state-specific allocations. Unused recreational catch can be re-allocated to commercial fisheries.</li>\n</ul>\n</li>\n</ul>\n', 'Habitat': '<ul>\n<li>Bluefish live in temperate and tropical coastal oceans around the world, except in the eastern Pacific.</li>\n<li>They gather by size in schools that can cover tens of square miles of ocean, equivalent to 10,000 football fields.</li>\n<li>Bluefish migrate seasonally, moving north in spring and summer as water temperatures rise and then south in autumn and winter to waters in the South Atlantic Bight.</li>\n<li>Females release their eggs in the open ocean.</li>\n<li>Larvae develop into juveniles near the surface in continental shelf waters and eventually move to estuarine and nearshore shelf habitats.</li>\n<li>Juveniles prefer sandy ocean bottoms but will also inhabit mud, silt, or clay ocean bottoms or vegetated areas.</li>\n<li>Adults live in both inshore and offshore areas and favor warmer water.</li>\n</ul>\n', 'Habitat Impacts': 'Recreational fishermen use hook-and-line gear that has minimal impacts on habitat. Commercial fishermen use a variety of gears including trawls, gillnets, haul seines, and pound nets, and the impacts vary by gear type.', 'Image Gallery': [{'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/01_10.jpg', 'alt': 'Bluefish have a prominent jaw, with sharp, compressed teeth.', 'title': 'Bluefish have a prominent jaw, with sharp, compressed teeth.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/02_8.jpg', 'alt': 'A recreational fisherman with his catch of bluefish. Bluefish are one of the most popular recreational species along the Atlantic coast.', 'title': 'A recreational fisherman with his catch of bluefish. Bluefish are one of the most popular recreational species along the Atlantic coast.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/03_6.jpg', 'alt': 'A historic photo of a crew of New York bluefish fisherman.', 'title': 'A historic photo of a crew of New York bluefish fisherman.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/05_7.jpg', 'alt': 'Filleting freshly-caught bluefish.', 'title': 'Filleting freshly-caught bluefish.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/06_3.jpg', 'alt': 'Bluefish in the pan.', 'title': 'Bluefish in the pan.'}], 'Location': '<ul>\n<li>Along the East Coast from Maine to eastern Florida.</li>\n</ul>\n', 'Management': None, 'NOAA Fisheries Region': 'Greater Atlantic', 'Population': 'Significantly below target population level. A rebuilding plan is in place.', 'Population Status': '<ul>\n<li>According to the 2021 stock assessment, bluefish is overfished and not subject to overfishing. Summary stock assessment information can be found on <a href="https://www.st.nmfs.noaa.gov/stocksmart?stockname=Bluefish%20-%20Atlantic%20Coast&amp;stockid=10388">Stock SMART</a>.</li>\n</ul>\n', 'Scientific Name': 'Pomatomus saltatrix', 'Species Aliases': '<a href="/species-aliases/tailor" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Tailor</a>, <a href="/species-aliases/snapper" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Snapper</a>, <a href="/species-aliases/baby-blues" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Baby blues</a>, <a href="/species-aliases/choppers" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Choppers</a>, <a href="/species-aliases/elfs" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Elfs</a>', 'Species Illustration Photo': {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/bluefish.png', 'alt': 'Bluefish', 'title': 'Bluefish'}, 'Species Name': 'Bluefish', 'Animal Health': None, 'Availability': '<p>Fresh year-round, but varies by area. Not available frozen. Buy in season, and plan to cook within a day of purchase.</p>\n', 'Biology': '<ul>\n<li>Bluefish live up to 12&nbsp;years.</li>\n<li>They grow fast, up to 31 pounds and 39 inches.</li>\n<li>They are able to reproduce at age 2, when they’re 15 to 20 inches in length.</li>\n<li>Depending on their size, females can have between 400,000 and 2 million eggs.</li>\n<li>Bluefish spawn multiple times in spring and summer.</li>\n<li>They exhibit feeding behavior called the “bluefish blitz,” where large schools of big fish attack bait fish near the surface, churning the water like a washing machine. They feed voraciously on their prey, eating almost anything they can catch and swallow.</li>\n<li>Bluefish have razor-sharp teeth and shearing jaws that allow them to ingest large parts, increasing the maximum size of the prey they can eat.</li>\n<li>They eat squid and fish, particularly menhaden and smaller fish such as silversides.</li>\n<li>Sharks, tunas, and billfishes are typically the only fish predators large and fast enough to prey on adult bluefish.</li>\n<li>Bluefish make up a major part of the diet of <a href="https://www.fishwatch.gov/profiles/atlantic-shortfin-mako-shark">shortfin mako sharks</a>&nbsp;and are also very important in the diets of <a href="https://www.fishwatch.gov/profiles/north-atlantic-swordfish">swordfish</a>.</li>\n<li>Oceanic birds prey on juvenile bluefish.</li>\n</ul>\n', 'Bycatch': 'Regulations are in place to minimize bycatch.', 'Calories': '124', 'Carbohydrate': '0 g', 'Cholesterol': '59 mg', 'Color': '<p>The meat of raw bluefish is light putty to blue-gray in color with a brownish tinge. It becomes lighter when cooked.</p>\n', 'Disease Treatment and Prevention': None, 'Diseases in Salmon': None, 'Displayed Seafood Profile Illustration': None, 'Ecosystem Services': None, 'Environmental Considerations': None, 'Environmental Effects': None, 'Farming Methods': None, 'Farming Methods_': None, 'Fat, Total': '4.24 g', 'Feeds_': None, 'Feeds': None, 'Fiber, Total Dietary': '0 g', 'Fishing Rate': 'At recommended level.', 'Harvest': '<ul>\n<li>In 2021, commercial landings of bluefish totaled more than 2.4 million pounds and were valued at $2.2 million, according to the NOAA Fisheries <a href="https://www.fisheries.noaa.gov/foss/f?p=215:200:3577333744020::NO:::">commercial fishing landings database</a>.</li>\n<li>In 2021, recreational anglers landed 12.8&nbsp;million pounds of bluefish, according to the NOAA Fisheries<a href="https://www.fisheries.noaa.gov/foss/f?p=215:200:3577333744020::NO:::"> recreational fishing landings database</a>.</li>\n<li>Florida, North Carolina, and New Jersey account for the largest percentage of the recreational bluefish harvest.</li>\n<li>Peak recreational harvest occurs from May through October with over 70 percent of the catch in July and August.</li>\n<li>Gear types, habitat impacts, and bycatch:\n<ul>\n<li>Recreational fishermen use hook-and-line gear that has minimal impacts on habitat.</li>\n<li>Commercial fishermen use a variety of gears including trawls, gillnets, haul seines, and pound nets, and the impacts vary by gear type.</li>\n<li>Gillnets can occasionally entangle marine mammals. However, the bluefish fishery uses nets with small mesh and sinking gillnets to reduce bycatch.</li>\n</ul>\n</li>\n</ul>\n', 'Harvest Type': 'Wild', 'Health Benefits': '<p>Bluefish are a good source of selenium, niacin, vitamin B12, magnesium, and potassium. As apex predators, bluefish can accumulate comparatively high levels of mercury and PCB contaminants. Limited consumption has been recommended in some states.</p>\n', 'Human_Health_': None, 'Human Health': None, 'Physical Description': '<ul>\n<li>Bluefish are blue-green on the back and silvery on the sides and belly.</li>\n<li>They have a prominent jaw, with sharp, compressed teeth.</li>\n</ul>\n', 'Production': None, 'Protein': '20.04 g', 'Quote': 'U.S. wild-caught bluefish is a smart seafood choice because it is sustainably managed and responsibly harvested under U.S. regulations.', 'Quote Background Color': '#89aec3', 'Research': '<ul>\n<li>Several key scientific gaps need to be addressed to better inform management. For example, more research is needed on the relationship between the age and length of bluefish, how much bluefish is caught and discarded in the commercial fisheries for bluefish and other species, the resulting impacts, and general population trends. There is also uncertainty in the methods used by scientists to monitor bluefish abundance and in estimating recreational catch along the Atlantic coast. In 2012, managers established a coast-wide sampling program designed to improve the quantity and quality of information used in future bluefish stock assessments.</li>\n<li>The coast-wide&nbsp;sampling program resulted in a significant increase in the amount of age-length keys and catch-at-age data that was used in the 2015 benchmark assessment.</li>\n<li>The bluefish management plan allows managers to set aside a small percentage of the annual catch limit for research. Proceeds from the sale of this set-aside catch are used to fund research on the bluefish resource and fishery.</li>\n</ul>\n', 'Saturated Fatty Acids, Total': '0.915 g', 'Selenium': '36.5 mcg', 'Serving Weight': '100 g', 'Servings': '1', 'Sodium': '60 mcg', 'Source': '<p>U.S. wild-caught from Massachusetts to Florida.</p>\n', 'Sugars, Total': '0 g', 'Taste': '<p>Rich, full flavor. The larger the fish, the more pronounced the taste. A strong-flavored, dark strip of meat on the fillet may be removed before cooking.</p>\n', 'Texture': '<p>Coarse, moist meat with edible skin.</p>\n', 'Path': '/profiles/bluefish', 'last_update': '10/05/2022 - 14:57'}]
    received_text = getInformSelectSpecies("Bluefish")
    assert right_text != received_text
    
def test_integrationSpecificSpecies2():
    right_text = [{'Fishery Management': '<ul>\n<li><a href="https://www.fisheries.noaa.gov/region/southeast">NOAA Fisheries</a> and the <a href="http://www.safmc.net/">South Atlantic</a> and <a href="http://www.gulfcouncil.org/">Gulf of Mexico</a> Fishery Management Councils manage the red grouper fishery:</li>\n<li>In the South Atlantic, managed under the <a href="https://www.fisheries.noaa.gov/management-plan/south-atlantic-snapper-grouper-fishery-management-plan">Snapper-Grouper Fishery Management Plan</a>:\n<ul>\n<li>Commercial fishermen must have a permit to fish, land, or sell red grouper. Managers limit the number of available permits to control the number of fishermen harvesting red grouper.</li>\n<li>Annual catch limits are used for red grouper in the commercial and recreational fisheries. These fisheries are closed when their annual catch limit is projected to be met.</li>\n<li>Both the commercial and recreational fisheries have size limits to reduce harvest of immature red grouper.</li>\n<li>The commercial and recreational fishing seasons are closed from January through April to protect red grouper during their peak spawning period.</li>\n<li>Gear restrictions are used to reduce bycatch and protect habitat.</li>\n<li>There are eight deep-water marine protected areas and several spawning special management zones to protect habitats. The <a href="http://www.safmc.net/managed-areas/oculina-bank">Oculina Experimental Closed Area</a> is closed to fishing for and possession of all snappers and groupers to protect deepwater coral habitat and the reef fish it supports.</li>\n</ul>\n</li>\n<li>In the Gulf of Mexico, managed under the <a href="https://www.fisheries.noaa.gov/management-plan/gulf-mexico-reef-fish-fishery-management-plan">Reef Fish Fishery Management Plan</a>:\n<ul>\n<li>Commercial vessels must have a reef fish permit and individual fishing quota (IFQ) to harvest red grouper.</li>\n<li>The annual catch limit is allocated between the commercial (76 percent) and recreational (24 percent) fisheries.</li>\n<li>The IFQ program (<a href="https://www.fisheries.noaa.gov/national/laws-and-policies/catch-shares">catch shares</a>) allocates the commercial catch limit among shareholders with measures to prevent fishermen from harvesting more than their individual allocation.</li>\n<li>To reduce bycatch, there are restrictions on the type of gear fishermen may use and where they can fish.</li>\n<li>Minimum size limits protect immature red grouper.</li>\n<li>Year-round and/or seasonal area closures for commercial and recreational sectors to protect spawning groupers.&nbsp;</li>\n<li>Commercial data reporting requirements.</li>\n</ul>\n</li>\n<li>In the U.S. Caribbean:\n<ul>\n<li>Annual catch limits.</li>\n<li>Seasonal closure from February 1 through April 30.</li>\n</ul>\n</li>\n</ul>\n', 'Habitat': '<ul>\n<li>Red grouper are referred to as shallow-water grouper because they’re common in waters 10 to 60 feet deep.</li>\n<li>Juveniles prefer grass beds, rock formations, and reefs in shallow, nearshore waters. They move offshore as they mature.</li>\n<li>Adults are most commonly found around ledges, crevices, and caverns of rocky limestone reefs, and also near lower-profile, live-bottom (sponges, corals and sea squirts) areas.</li>\n<li>Adults may school or move together as groups, but only for short distances.</li>\n<li>Red grouper play a significant role in their underwater environment by acting as “marine engineers.” They&nbsp;excavate flat-bottom areas creating habitat for themselves and other commercially important species, such as <a href="https://www.fishwatch.gov/profiles/caribbean-spiny-lobster">spiny lobster</a>, <a href="https://www.fishwatch.gov/profiles/black-grouper">black grouper</a>, red porgy, and <a href="https://www.fishwatch.gov/profiles/vermilion-snapper">vermilion snapper</a>.</li>\n</ul>\n', 'Habitat Impacts': 'Fishing gear used to catch red grouper rarely contacts the ocean bottom and has minimal impacts on habitat.', 'Image Gallery': [{'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/red-grouper_2.jpg', 'alt': 'Red grouper have large mouths, which allow them to eat their prey whole image.', 'title': 'Red grouper have large mouths, which allow them to eat their prey whole.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/red-grouper_3.jpg', 'alt': 'Red grouper image.', 'title': 'Red grouper.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/red-grouper_4.jpg', 'alt': 'Red grouper swims through its reef habitat image.', 'title': 'Red grouper swims through its reef habitat.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/red-grouper_5.jpg', 'alt': 'Red grouper spawning image.', 'title': 'Red grouper spawning.'}, {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/red-grouper_1.jpg', 'alt': 'Red grouper image.', 'title': ''}], 'Location': '<ul>\n<li>Red grouper are found in the western Atlantic Ocean from Massachusetts through the Gulf of Mexico and south to Brazil.&nbsp;</li>\n</ul>\n', 'Management': None, 'NOAA Fisheries Region': 'Southeast', 'Population': 'Above target population level in the Gulf of Mexico. Significantly below target population level in the South Atlantic. A rebuilding plan is in place for the South Atlantic stock.', 'Population Status': '<ul>\n<li>\n<p>There are two stocks of red grouper: the Gulf of Mexico stock and the South Atlantic stock. According to the most recent stock assessments:</p>\n<ul>\n<li>\n<p>The Gulf of Mexico stock is not overfished (2019 stock assessment), and is not subject to overfishing based on 2020&nbsp;catch data.&nbsp; Summary stock assessment information can be found on <a href="https://www.st.nmfs.noaa.gov/stocksmart?app=browse_by_stock&amp;stockid=10331">Stock SMART</a>.</p>\n</li>\n<li>\n<p>The South Atlantic stock is overfished (2017 stock assessment), but is not subject to overfishing based on 2020&nbsp;catch data.&nbsp; Summary stock assessment information can be found on <a href="https://www.st.nmfs.noaa.gov/stocksmart?app=browse_by_stock&amp;stockid=10332">Stock SMART</a>. A rebuilding plan has been in place since 2012.</p>\n</li>\n</ul>\n</li>\n</ul>\n', 'Scientific Name': 'Epinephelus morio', 'Species Aliases': '<a href="/species-aliases/grouper" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Grouper</a>, <a href="/species-aliases/cherna-americana" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Cherna americana</a>, <a href="/species-aliases/negre" typeof="skos:Concept" property="rdfs:label skos:prefLabel" datatype="">Negre</a>', 'Species Illustration Photo': {'src': 'https://origin-east-01-drupal-fishwatch.woc.noaa.gov/sites/default/files/red_grouper.png', 'alt': 'Red Grouper', 'title': 'Red Grouper'}, 'Species Name': 'Red Grouper', 'Animal Health': None, 'Availability': '<p>Year-round.</p>\n', 'Biology': '<ul>\n<li>Red grouper grow slowly, up to almost 50 inches long and more than 50 pounds.</li>\n<li>The oldest recorded red grouper in the South Atlantic was 26 years old and the oldest recorded in the Gulf of Mexico was 29 years old.</li>\n<li>They are protogynous hermaphrodites – they begin life as females and sexually mature when they reach 4 to 6 years of age. Some later transform into males, most often between the ages of 7 and 15. The proportion of males in the population increases with age.</li>\n<li>They spawn frequently, close to 26 times a year, in shallow waters from February through June.</li>\n<li>Red grouper feed on a wide variety of fish, octopus, and crustaceans, including shrimp, lobsters, and mantis shrimp.</li>\n<li>They are among the top predators in reef community food webs and may control some aspects of community balance in reef systems. Red grouper are unspecialized and opportunistic feeders – they eat any convenient prey. They engulf prey whole by opening their large mouths, dilating their gill covers, rapidly drawing in a current of water, and inhaling the food.</li>\n<li>Smaller grouper are preyed on by the same predators that eat snappers, including jacks, other groupers, sharks, barracudas, and morays. Large sharks and carnivorous marine mammals prey on adult red grouper.</li>\n</ul>\n', 'Bycatch': 'Regulations are in place to minimize bycatch.', 'Calories': '92', 'Carbohydrate': '0 g', 'Cholesterol': '37 mg', 'Color': '<p>Raw and cooked meat is white.</p>\n', 'Disease Treatment and Prevention': None, 'Diseases in Salmon': None, 'Displayed Seafood Profile Illustration': None, 'Ecosystem Services': None, 'Environmental Considerations': None, 'Environmental Effects': None, 'Farming Methods': None, 'Farming Methods_': None, 'Fat, Total': '1.02 g', 'Feeds_': None, 'Feeds': None, 'Fiber, Total Dietary': '0 g', 'Fishing Rate': 'At recommended levels in the Gulf of Mexico and the South Atlantic.', 'Harvest': '<ul>\n<li>Commercial fishery:&nbsp;\n<ul>\n<li>In 2020, commercial landings of red grouper totaled 2.8 million pounds and were valued at approximately $12 million, according to the NOAA Fisheries <a href="https://foss.nmfs.noaa.gov/apexfoss/f?p=215:200:14440981298202::NO:::">commercial fishing landings database</a>.&nbsp;</li>\n</ul>\n</li>\n<li>Gear types, habitat impacts, and bycatch:\n<ul>\n<li>Commercial fishermen mainly use hook-and-line gear, including longlines and handlines, to harvest red grouper.&nbsp;</li>\n<li>Trawl gear, fish traps, and bottom longlines are prohibited in some areas to reduce bycatch. Several areas are closed to all fishing to protect snappers and groupers, including red grouper.</li>\n<li>Sea turtles and other reef fishes, such as snappers and groupers, can be incidentally caught while fishing for red grouper.&nbsp;</li>\n<li>In certain areas, fishermen are required to use circle hooks to improve the chance of survival of any unintentionally caught fish and to reduce turtle hookings.&nbsp;</li>\n<li>Commercial and charterboat/headboat reef fish fishermen must use appropriate release gear and follow handling protocols to increase the chance of survival for any incidentally caught <a href="http://sero.nmfs.noaa.gov/sustainable_fisheries/gulf_sa/turtle_sawfish_release/index.html">sea turtles</a>.&nbsp;</li>\n<li>Fishermen are encouraged to use <a href="https://www.flseagrant.org/fisheries/venting/" rel="external">venting tools</a>&nbsp;or <a href="https://returnemright.org/barotrauma/" rel="external">fish descenders</a>&nbsp;when fish are caught showing signs of barotrauma. Barotrauma occurs when reef fish are quickly brought to the surface by hook-and-line and the gas in their swimbladders expands. <a href="https://www.flseagrant.org/fisheries/venting/" rel="external">Venting tools</a>&nbsp;help deflate the expanded abdominal cavity, potentially reduce injury to the fish, and make it easier to return to deep water.</li>\n</ul>\n</li>\n<li>Recreational fishery:\n<ul>\n<li>Red grouper is a popular fish among recreational fishermen in the South Atlantic and Gulf of Mexico.</li>\n<li>In 2020, recreational anglers landed 2.9 million pounds of red grouper, according to the NOAA Fisheries <a href="https://foss.nmfs.noaa.gov/apexfoss/f?p=215:200:14440981298202::NO:::">recreational fishing landings database</a>.&nbsp;&nbsp;</li>\n<li>In the South Atlantic:\n<ul>\n<li>Annual catch limits&nbsp;and accountability measures.</li>\n<li>Bag and size limits.</li>\n<li>The fishery is closed during the spawning season (from January through April).</li>\n</ul>\n</li>\n<li>In the Gulf of Mexico:\n<ul>\n<li>Annual catch limits&nbsp;and accountability measures.</li>\n<li>Bag and size limits.</li>\n<li>The fishery is closed during the spawning season (from February 1 through March 31) in deep water to protect spawning aggregations.</li>\n</ul>\n</li>\n<li>In the U.S. Caribbean:\n<ul>\n<li>Annual catch limits.</li>\n<li>Seasonal closure from February 1 through April 30.</li>\n<li>Bag and vessel limits.</li>\n</ul>\n</li>\n</ul>\n</li>\n</ul>\n', 'Harvest Type': 'Wild', 'Health Benefits': '<p>Red grouper is low in saturated fat, and a good source of vitamins B6 and B12, phosphorus, potassium, protein, and selenium.</p>\n', 'Human_Health_': None, 'Human Health': None, 'Physical Description': '<ul>\n<li>Red grouper have robust bodies with small scales.</li>\n<li>Their head and body are dark reddish brown, shading pink or reddish below with occasional white spots on the sides and black spots on the cheeks.</li>\n<li>They have large mouths with a lower jaw that often projects slightly beyond their upper jaw, with bands of slender, sharp teeth, and usually a few stout, fixed canines.</li>\n<li>Their large mouths allow them to eat their prey whole.&nbsp;</li>\n</ul>\n', 'Production': None, 'Protein': '19.38 g', 'Quote': 'Although some populations are below target levels, U.S. wild-caught red grouper is still a smart seafood choice because it is sustainably managed and responsibly harvested under U.S. regulations.  ', 'Quote Background Color': '#5f231e', 'Research': '<ul>\n<li><a href="https://www.sefsc.noaa.gov/species/fish/reeffish.htm">NOAA Southeast Fisheries Science Center Reef Fish Research</a></li>\n</ul>\n', 'Saturated Fatty Acids, Total': '0.233 g', 'Selenium': '36.5 mcg', 'Serving Weight': '100 g', 'Servings': '1', 'Sodium': '53 mg', 'Source': '<p>U.S. wild-caught from Massachusetts to the Gulf of Mexico.</p>\n', 'Sugars, Total': '0 g', 'Taste': '<p>Red grouper has a mild but distinct flavor, somewhere between bass and halibut. Red grouper is sweeter and milder than black grouper, and many consider red grouper the tastier of the two.</p>\n', 'Texture': '<p>Very firm, moist, and flaky.</p>\n', 'Path': '/profiles/red-grouper', 'last_update': '10/05/2022 - 16:17'}]
    received_text = getInformSelectSpecies("Red Grouper")
    assert right_text == received_text
